gitweb: Add mod_perl version string to "generator" meta header
[git/dscho.git] / git-pull.sh
blob1703091bbb988e22f39b2c8d4c70ec7340a2f109
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-summary] [--no-commit] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
9 . git-sh-setup
11 strategy_args= no_summary= no_commit= squash=
12 while case "$#,$1" in 0) break ;; *,-*) ;; *) break ;; esac
14 case "$1" in
15 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
16 --no-summa|--no-summar|--no-summary)
17 no_summary=-n ;;
18 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
19 no_commit=--no-commit ;;
20 --sq|--squ|--squa|--squas|--squash)
21 squash=--squash ;;
22 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
23 --strateg=*|--strategy=*|\
24 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
25 case "$#,$1" in
26 *,*=*)
27 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
28 1,*)
29 usage ;;
31 strategy="$2"
32 shift ;;
33 esac
34 strategy_args="${strategy_args}-s $strategy "
36 -h|--h|--he|--hel|--help)
37 usage
39 -*)
40 # Pass thru anything that is meant for fetch.
41 break
43 esac
44 shift
45 done
47 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
48 git-fetch --update-head-ok --reflog-action=pull "$@" || exit 1
50 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
51 if test "$curr_head" != "$orig_head"
52 then
53 # The fetch involved updating the current branch.
55 # The working tree and the index file is still based on the
56 # $orig_head commit, but we are merging into $curr_head.
57 # First update the working tree to match $curr_head.
59 echo >&2 "Warning: fetch updated the current branch head."
60 echo >&2 "Warning: fast forwarding your working tree from"
61 echo >&2 "Warning: commit $orig_head."
62 git-update-index --refresh 2>/dev/null
63 git-read-tree -u -m "$orig_head" "$curr_head" ||
64 die 'Cannot fast-forward your working tree.
65 After making sure that you saved anything precious from
66 $ git diff '$orig_head'
67 output, run
68 $ git reset --hard
69 to recover.'
73 merge_head=$(sed -e '/ not-for-merge /d' \
74 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
75 tr '\012' ' ')
77 case "$merge_head" in
78 '')
79 curr_branch=$(git-symbolic-ref HEAD | \
80 sed -e 's|^refs/heads/||')
81 echo >&2 "Warning: No merge candidate found because value of config option
82 \"branch.${curr_branch}.merge\" does not match any remote branch fetched."
83 echo >&2 "No changes."
84 exit 0
86 ?*' '?*)
87 if test -z "$orig_head"
88 then
89 echo >&2 "Cannot merge multiple branches into empty head"
90 exit 1
92 var=`git-repo-config --get pull.octopus`
93 if test -n "$var"
94 then
95 strategy_default_args="-s $var"
99 var=`git-repo-config --get pull.twohead`
100 if test -n "$var"
101 then
102 strategy_default_args="-s $var"
105 esac
107 if test -z "$orig_head"
108 then
109 git-update-ref -m "initial pull" HEAD $merge_head "" &&
110 git-read-tree --reset -u HEAD || exit 1
111 exit
114 case "$strategy_args" in
116 strategy_args=$strategy_default_args
118 esac
120 merge_name=$(git-fmt-merge-msg <"$GIT_DIR/FETCH_HEAD") || exit
121 git-merge "--reflog-action=pull $*" \
122 $no_summary $no_commit $squash $strategy_args \
123 "$merge_name" HEAD $merge_head